import java.io.*;
import antlr.CommonAST;
import antlr.collections.AST;
import antlr.DumpASTVisitor;
import antlr.ParserException;
import antlr.ScannerException;


class Calc {
	public static void main(String[] args) {
		try {
			CalcLexer lexer = new CalcLexer(new DataInputStream(System.in));
			CalcParser parser = new CalcParser(lexer);
			// Parse the input expression
			try {
				parser.expr();
			}
			catch (IOException io) {
				System.err.println("IOException while parsing");
			}
			CommonAST t = (CommonAST)parser.getAST();
			// Print the resulting tree out in LISP notation
			System.out.println(t.toStringTree());
			CalcTreeWalker walker = new CalcTreeWalker();
			// Traverse the tree created by the parser
			float r = walker.expr(t);
			System.out.println("value is "+r);
		} catch(ParserException e) {
			System.err.println("exception: "+e);
		}
	}
}
