/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: JNumberLiteral.java,v 1.2 2002/03/08 21:54:34 mrobilla Exp $
 */

package at.dms.kjc;

import at.dms.compiler.TokenReference;

/**
 * Root class for all number literals
 */
public abstract class JNumberLiteral extends JLiteral {

  // ----------------------------------------------------------------------
  // CONSTRUCTORS
  // ----------------------------------------------------------------------

  /**
   * Construct a node in the parsing tree
   * @param where  the line of this node in the source code
   */
  public JNumberLiteral(TokenReference where) {
    super(where);
  }

  // ----------------------------------------------------------------------
  // ACCESSORS
  // ----------------------------------------------------------------------

  /**
   * Returns the literal value of an expression
   */
  public boolean isDefault() {
    return numberValue().doubleValue() == 0;
  }

  /**
   * get a Number that represents the value of this literal
   * Do not call before checkBody
   */
  public abstract Number numberValue();

}
